import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class ChessBoard here.
 * 
 * @author Steve Putz
 * @version 18-March-2014
 */
public class ChessBoard extends World
{
    public final static int ROWS = 8;
    public final static int COLS = 8;
    private GreenfootImage savedBackground;
    
    /**
     * Constructor for objects of class ChessBoard.
     * 
     */
    public ChessBoard()
    {    
        super(COLS, ROWS, 60);
        savedBackground = getBackground();
        resetBoard();
        prepare();
    }

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
        KnightActor knightactor = new KnightActor();
        addObject(knightactor, 0, 0);
    }
    
    
    public void resetBoard()
    {
        setBackground(new GreenfootImage(savedBackground));
    }
    
    
    
    public void drawMove(int x1, int y1, int x2, int y2, String label, Color color1, Color color2)
    {
        int cs = getCellSize();
        int mid = cs/2;
        getBackground().setColor(color1);
        getBackground().drawLine(mid+x1*cs, mid+y1*cs, mid+x2*cs, mid+y2*cs);
        getBackground().fillOval(mid+x2*cs-9, mid+y2*cs-9, 19, 19);
        getBackground().setColor(color2);
        getBackground().drawString(label, mid+x2*cs-5, mid+y2*cs+5);
        
    }
}
