import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Point;
import java.awt.Color;

/**
 * Write a description of class KnightActor here.
 * 
 * @author Steve Putz
 * @version 18-Apr-2013
 */
public class KnightActor extends Actor
{
    Point[] steps;
    int currentStep;
         
    public void solve()
    {
//         long start = System.currentTimeMillis();
        steps = WarnsdorffKnight.findSolution(getX(), getY());
        currentStep = 0;
//         long now = System.currentTimeMillis();
//         System.out.println("time: " + (now - start) + " msec");
    }
                    
    
    public void reset()
    {
        ((ChessBoard)getWorld()).resetBoard();
        steps = null;
    }
    

    /**
     * Act - do whatever the KnightActor wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if (steps == null) {
            solve();
        }
        Point current = steps[currentStep];
        if (current != null && (current.x != getX() || current.y != getY())) {
            reset();
            solve();
        }
        currentStep = (currentStep + 1) % steps.length;
        if (steps[currentStep] == null) currentStep = 0;
        Point next = steps[currentStep];
        if (next == null) {
            Greenfoot.stop();
            return;
        }
        int oldX = getX();
        int oldY = getY();
        setLocation(next.x, next.y);
        if (currentStep == 0) {
            Greenfoot.stop();
        }
        if (currentStep != 0) {
            int r = currentStep * 256 / steps.length;
            int g = 0;
            int b = 255- r;
            Color color = new Color(r, g, b);
            ((ChessBoard)getWorld()).drawMove(oldX, oldY, getX(), getY(), ""+currentStep, color, Color.white);
        }
    }    
}
